<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\Fm070000ParametrosSensorService;
use FM\Traits\TResponse;

class Fm070000ParametrosSensorController extends FMCrud
{

    use TResponse;

    protected $Fm070000ParametrosSensorService;

    public function __construct($crudService, $environment, Fm070000ParametrosSensorService $Fm070000ParametrosSensorService)
    {
        parent::__construct($crudService, $environment);
        $this->Fm070000ParametrosSensorService = $Fm070000ParametrosSensorService;
    }

    public function getParamLeitContPessoas()
    {
        try {
            $data = $this->Fm070000ParametrosSensorService->getParamLeitContPessoas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirSensor(DTO\Request $request)
    {
        try {
            $this->Fm070000ParametrosSensorService->inserirSensor($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarParametrosSensor(DTO\Request $request)
    {
        try {
            $this->Fm070000ParametrosSensorService->deletarParametrosSensor($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
