<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\HierarquiaFuncService;

class HierarquiaFuncController extends FMCrud
{

    protected $dataSourceName = 'fcm_checklistagend';
    protected $HierarquiaFuncService;

    public function __construct($crudService, $environment, HierarquiaFuncService $HierarquiaFuncService)
    {
        parent::__construct($crudService, $environment);
        $this->HierarquiaFuncService = $HierarquiaFuncService;
    }

    // Insere uma nova hierarquia
    public function insertHierarchy(DTO\Request $request, DTO\Response $response)
    {
        $params = $request->getParameters();

        $var = $this->HierarquiaFuncService->insertHierarchy($params);

        $dtsVal = new DataSet('info', array('error' => $var));
        $response->addDataSet($dtsVal);
    }

    // Busca todas as hierarquias
    public function getHierarchies(DTO\Response $response)
    {
        $var = $this->HierarquiaFuncService->getHierarchies();

        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }

    // Busca o nr da hierarquia ativa
    public function getActiveHierarchyId(DTO\Response $response)
    {
        $var = $this->HierarquiaFuncService->getActiveHierarchyId();

        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }

    // Ativa a hierarquia
    public function activateHierarchy(DTO\Request $request, DTO\Response $response)
    {
        $params = $request->getParameters();

        $var = $this->HierarquiaFuncService->activateHierarchy($params);

        $dtsVal = new DataSet('info', array('error' => $var));
        $response->addDataSet($dtsVal);
    }
}
