<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\RelatoriosTarefasService;
use FM\Traits\TResponse;

class RelatoriosTarefasController extends FMCrud
{

    use TResponse;

    protected $RelatoriosTarefasService;

    public function __construct($crudService, $environment, RelatoriosTarefasService $RelatoriosTarefasService)
    {
        parent::__construct($crudService, $environment);
        $this->RelatoriosTarefasService = $RelatoriosTarefasService;
    }

    public function getRelatoriosTarefas()
    {
        try {
            $data = $this->RelatoriosTarefasService->getRelatoriosTarefas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDashRelatorioTarefas()
    {
        try {
            $data = $this->RelatoriosTarefasService->getDashRelatorioTarefas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensTarefas(Request $request)
    {
        try {
            $data = $this->RelatoriosTarefasService->getItensTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosTarefas(Request $request)
    {
        try {
            $data = $this->RelatoriosTarefasService->getFotosTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // public function getFiltroRelatorioTarefa()
    // {
    //     try {
    //         $data = $this->RelatoriosTarefasService->getFiltroRelatorioTarefa();
    //         $this->sendResponse($data, 200);
    //     } catch (\Exception $ex) {
    //         $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
    //     }
    // }

    public function getFiltroRelatorioLocal()
    {
        try {
            $data = $this->RelatoriosTarefasService->getFiltroRelatorioLocal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroRelatorioChecklist()
    {
        try {
            $data = $this->RelatoriosTarefasService->getFiltroRelatorioChecklist();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroRelatorioCliente()
    {
        try {
            $data = $this->RelatoriosTarefasService->getFiltroRelatorioCliente();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
