<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use FM\Service\RelatoriosVistoriaService;
use FM\Traits\TResponse;

class RelatoriosVistoriaController extends FMCrud
{

    use TResponse;

    protected $RelatoriosVistoriaService;

    public function __construct($crudService, $environment, RelatoriosVistoriaService $RelatoriosVistoriaService)
    {
        parent::__construct($crudService, $environment);
        $this->RelatoriosVistoriaService = $RelatoriosVistoriaService;
    }

    public function getRelatoriosVistoria()
    {
        try {
            $data = $this->RelatoriosVistoriaService->getRelatoriosVistoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosVistoria(Request $request)
    {
        try {
            $data = $this->RelatoriosVistoriaService->getCriteriosVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosVistoria(Request $request)
    {
        try {
            $data = $this->RelatoriosVistoriaService->getFotosVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaLocal()
    {
        try {
            $data = $this->RelatoriosVistoriaService->getFiltroVistoriaLocal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaChecklist()
    {
        try {
            $data = $this->RelatoriosVistoriaService->getFiltroVistoriaChecklist();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaCliente()
    {
        try {
            $data = $this->RelatoriosVistoriaService->getFiltroVistoriaCliente();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaSituacao()
    {
        try {
            $data = $this->RelatoriosVistoriaService->getFiltroVistoriaSituacao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
