<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class HierarquiaFuncFactory
{
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    // Busca toda as hierarquias
    public function getHierarchies()
    {
        $sql = "SELECT NRHIERARQUIAFUNC, NMHIERARQUIAFUNC, IDATIVO
                    FROM FCM_HIERARQUIAFUNC
                ORDER BY DTINCLUSAO";

        $this->connection->executeStatement($sql);
    }

    // Busca toda as hierarquias
    public function getActiveHierarchyId()
    {
        $sql = "SELECT NRHIERARQUIAFUNC
                    FROM FCM_HIERARQUIAFUNC
                 WHERE IDATIVO = 'S'";

        $this->connection->executeStatement($sql);
    }

    // Insere uma nova hierarquia
    public function insertHierarchy($params)
    {
        $sql = "INSERT INTO FCM_HIERARQUIAFUNC (NRHIERARQUIAFUNC,  NMHIERARQUIAFUNC, NRORG, DTINCLUSAO)
                    VALUES (:NRHIERARQUIAFUNC, :NMHIERARQUIAFUNC, :NRORG, SYSDATE)";

        $this->connection->executeStatement($sql, $params);
    }

    // Desativa a hierarquia que estava ativa
    public function deactivateHierarchy()
    {
        $sql = "UPDATE FCM_HIERARQUIAFUNC
                    SET IDATIVO = 'N'
                 WHERE IDATIVO = 'S' ";

        $this->connection->executeStatement($sql);
    }

    // Ativa hierarquia
    public function activateHierarchy($nrhierarquiafunc)
    {
        $sql = "UPDATE FCM_HIERARQUIAFUNC
                    SET IDATIVO = 'S'
                 WHERE NRHIERARQUIAFUNC = {$nrhierarquiafunc}";

        $this->connection->executeStatement($sql);
    }
}
