<?php

namespace FM\Service;

use FM\Factory\RelatoriosVistoriaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Service\FuncionariosHierarqService;

class RelatoriosVistoriaService
{

    protected $RelatoriosVistoriaFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct(RelatoriosVistoriaFactory $RelatoriosVistoriaFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode)
    {
        $this->RelatoriosVistoriaFactory    = $RelatoriosVistoriaFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getRelatoriosVistoria()
    {

        $cdoperador = $this->Environment->getCdOperador();
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);

        $params = array(
            "CDOPERADOR" => $cdoperador,
        );

        return $this->RelatoriosVistoriaFactory->getRelatoriosVistoria($listaOperadores, $params);
    }

    public function getCriteriosVistoria($parametros)
    {
        return $this->RelatoriosVistoriaFactory->getCriteriosVistoria($parametros['NRGERENCIAMENTOCHK']);
    }

    public function getFotosVistoria($parametros)
    {
        return $this->RelatoriosVistoriaFactory->getFotosVistoria($parametros['NRGERENCIAMENTOCHK']);
    }

    // public function getFiltroVistoriaTarefa()
    // {
    //     return $this->RelatoriosVistoriaFactory->getFiltroVistoriaTarefa();
    // }

    public function getFiltroVistoriaLocal()
    {
        return $this->RelatoriosVistoriaFactory->getFiltroVistoriaLocal();
    }

    public function getFiltroVistoriaChecklist()
    {
        return $this->RelatoriosVistoriaFactory->getFiltroVistoriaChecklist();
    }

    public function getFiltroVistoriaCliente()
    {
        return $this->RelatoriosVistoriaFactory->getFiltroVistoriaCliente();
    }

    public function getFiltroVistoriaSituacao()
    {
        return $this->RelatoriosVistoriaFactory->getFiltroVistoriaSituacao();
    }
}
