/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DSTP                                                     */
/* Tabela : DESTPROD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DSTP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_DSTP
GO

CREATE TRIGGER DTULTATU_DSTP
ON DESTPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DESTPROD', null, 'CDDESTPROD='+ CDDESTPROD+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DESTPROD
      SET DTULTATUDSTP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DESTPROD.CDDESTPROD,0) = ISNULL(INSERTED.CDDESTPROD,0)) OR
            (ISNULL(DESTPROD.DSDESTPROD,0) = ISNULL(INSERTED.DSDESTPROD,0));
   END;
END;
GO

